#define _USE_MATH_DEFINES

#include <cmath>
#include <iostream>
#include "BExperiment.h"
#include "GravityAdaptive.h"

bool BExperiment::DoExperiment(char *argv[], const int argc, const Vec3 *gravity,
							   const int samples, const Vec3 *data,
							   double *output)
{
	double b = 0.0;
	double bStep = M_PI/(double)samples;
	Vec3 dummy;

	if (argc < 1)
	{
		return false;
	}

	for (int i = 0; i < samples; i++)
	{
		GravityAdaptive gm(*gravity, b, atof(argv[0]));
		output[i] = 0;

		for (int j = 0; j < samples; j++)
		{
			if (!gm.IsWithinBounds(data[j]))
			{
				output[i] += 1.0;
			}
			gm.GetEstimate(data[j], dummy);
		}

		b += bStep;
	}

	return true;
}