#define _USE_MATH_DEFINES

#include <cmath>
#include <iostream>
#include "KExperiment.h"
#include "GravityAdaptive.h"

bool KExperiment::DoExperiment(char *argv[], const int argc, const Vec3 *gravity,
							   const int samples, const Vec3 *data,
							   double *output)
{
	double k = 0.0;
	double kStep = 1.0/(double)samples;
	Vec3 dummy;

	for (int i = 0; i < samples; i++)
	{
		GravityAdaptive gm(*gravity, M_PI/6, k);
		output[i] = 0;
		
		for (int j = 0; j < samples; j++)
		{
			if (!gm.IsBaseCandidate(data[j]))
			{
				output[i] += 1.0;
			}
			gm.GetEstimate(data[j], dummy);
		}

		k += kStep;
	}

	return true;
}